Subject: Re: [PATCH net-next 0/2] veth: a couple of fixes

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Fri, 18 Nov 2022 12:05:39 +0100

Paolo Abeni <[email-masked]> writes:

> On Fri, 2022-11-18 at 00:33 +0100, Paolo Abeni wrote:
>> Recent changes in the veth driver caused a few regressions
>> this series addresses a couple of them, causing oops.
>> 
>> Paolo Abeni (2):
>>   veth: fix uninitialized napi disable
>>   veth: fix double napi enable
>> 
>>  drivers/net/veth.c | 6 ++++--
>>  1 file changed, 4 insertions(+), 2 deletions(-)
>
> @Xuan Zhuo: another option would be reverting 2e0de6366ac1 ("veth:
> Avoid drop packets when xdp_redirect performs") and its follow-up
> 5e5dc33d5dac ("bpf: veth driver panics when xdp prog attached before
> veth_open").
>
> That option would be possibly safer, because I feel there are other
> issues with 2e0de6366ac1, and would offer the opportunity to refactor
> its logic a bit: the napi enable/disable condition is quite complex and
> not used consistently mixing and alternating the gro/xdp/peer xdp check
> with the napi ptr dereference.
>
> Ideally it would be better to have an helper alike
> napi_should_be_enabled(), use it everywhere, and pair the new code with
> some selftests, extending the existing ones.
>
> WDYT?

FWIW, the original commit 2e0de6366ac1 was merged very quickly without
much review; so I'm not terribly surprised it breaks. I would personally
be OK with just reverting it...

-Toke